<?php
function insert_data($table)
{
	global $mysql_db, $conn, $start_timer, $max_execution_time, $_start;
	
	$max_execution_time = 55;
	
	## Get table size/num records
	
	if (!$_start)
	{
		$sql = "SELECT COUNT(*) AS count FROM $table";	
		$rs = &$conn->Execute($sql);
		$table_counter = ($rs && !$rs->EOF)? $rs->fields['count'] : 0;
		$dump_lim = ($table_counter > 100000)? 2000 : 1000;			
		$_start = 0;
	}	
	
	$dump_lim = isset($dump_lim)? $dump_lim : 1000;
	
	if (($table_counter && !$_start) || $_start)
	{
		while ((time() - $start_timer) < ($max_execution_time + $last_delta))
		{
			$local_timer = time();	
					
			$sql = "SELECT * FROM $table LIMIT $_start, $dump_lim";
			$rs = &$conn->Execute($sql) || exit();
						
			$insert = "";	
			$rows_count = 0;
			
			if (($rs && !$rs->EOF))
			{
				while ($rs && !$rs->EOF)
				{	
					$temp = $conn->GetInsertSQL($rs, $rs->fields);
					$temp = ereg_replace("\n","\\n", $temp);
					$temp = ereg_replace("\r","\\r", $temp);
					
					if (strlen($insert.= $temp.";\n") > (4*1024000))
					{
						SaveOnDisk($insert);								
						$insert = "";			
					}					
					$rows_count++;
					
					if ((time() - $start_timer) >= ($max_execution_time-5))
					{		
						$_start += $rows_count;
						return 0;					
					}
					
					$rs->MoveNext();
			    }       
			}
		    
		    if (strlen($insert))
			   SaveOnDisk($insert."\n");  			
			 
			$last_delta = time() - $local_timer;
			$_start += $dump_lim;			
			
			if ($rows_count < $dump_lim)
				break;			
		}		
		$ret = ($rows_count < $dump_lim)? 1 : 0;
	}
	else
		$ret = 1;
	   
    return $ret;
}

## Added in In-link 2.3.3
function SaveOnDisk($data)
{
	global $file;			
	$ret = fputs($file, $data);

	// SaveLog($data);	
		
	return void;
}

## Log table
function SaveLog($data)
{
	global $systemTables, $_start_table, $fp;
	
	/*
	$time = getdate();	
	$log = "[".$time['hours'].":".$time['minutes'].":".$time['seconds']."] - Writing to the disk: ";
	if (!empty($_start_table))
		$log.= $systemTables[$_start_table]." - ".strlen($data)."\n";
	else
		$log.= "Header OR Footer\n";
		
	fputs($fp, $log);	
	*/
}
## End Added

function create_tables()
{	
	global $sql_type;
	
	## SQL Type
	$dbtype = $sql_type;
	
	## Config
	if ($dbtype == "mysql")
		$inl_config_u = ", UNIQUE name (name)";
	elseif ($dbtype == "postgres7")
		$inl_config_u = ", UNIQUE (name)";
	elseif ($dbtype == "mssql")
		$inl_config_u = "";

	$query['inl_config'] = "CREATE TABLE inl_config (name varchar(255) NOT NULL, value varchar(255) NOT NULL, PRIMARY KEY (name) $inl_config_u);\n";
	## End Config
	
	
	if ($dbtype == "mysql")
		$idfield = "int NOT NULL auto_increment";
	elseif ($dbtype == "postgres7")
		$idfield = "serial";
	elseif ($dbtype == "mssql")
		$idfield = "int IDENTITY (1, 1) NOT NULL ";

	## Categories
	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_cats_cat_id_seq\"'::text) NOT NULL";
	
	$query['inl_cats'] = "CREATE TABLE inl_cats (cat_id $idfield, cat_name varchar(255), cat_desc TEXT NULL, cat_user INT DEFAULT '0' NOT NULL, cat_sub INT DEFAULT '0' NOT NULL, cat_perm SMALLINT DEFAULT '0' NOT NULL, cat_pend SMALLINT DEFAULT '0' NOT NULL, cat_vis SMALLINT DEFAULT '0' NOT NULL, cat_links INT DEFAULT '0' NOT NULL, cat_cats INT DEFAULT '0' NOT NULL, cat_date INT DEFAULT '0' NOT NULL, cat_pick INT DEFAULT '0' NOT NULL, cat_image VARCHAR(255) NULL, cat_cust INT DEFAULT '0' NOT NULL, meta_keywords TEXT NULL, meta_desc TEXT NULL, PRIMARY KEY (cat_id));\n";

    $query['inl_cats'].= "CREATE INDEX cat_sub ON inl_cats (cat_sub);\n";
    $query['inl_cats'].= "CREATE INDEX cat_name ON inl_cats (cat_name);\n";
    $query['inl_cats'].= "CREATE INDEX cat_user ON inl_cats (cat_user);\n";
    $query['inl_cats'].= "CREATE INDEX cat_pend ON inl_cats (cat_pend);\n";
    $query['inl_cats'].= "CREATE INDEX cat_vis ON inl_cats (cat_vis);\n";
    $query['inl_cats'].= "CREATE INDEX cat_pick ON inl_cats (cat_pick);\n";
    $query['inl_cats'].= "CREATE INDEX cat_cust ON inl_cats (cat_cust);\n";
    ## End Categories	
    	
	## Custom Fields
	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_custom_cust_id_seq\"'::text) NOT NULL";
	$query['inl_custom'] = "CREATE TABLE inl_custom (cust_id $idfield, cust1 VARCHAR(255) NULL, cust2 VARCHAR(255) NULL, cust3 VARCHAR(255) NULL, cust4 TEXT NULL, cust5 TEXT NULL, cust6 TEXT NULL, PRIMARY KEY (cust_id));\n";	
	// $query['inl_custom'].= "CREATE INDEX cust1 ON inl_custom (cust1);\n";
	## End Custom Fields
	
	## Email
	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_email_email_id_seq\"'::text) NOT NULL";
	$query['inl_email'] = "CREATE TABLE inl_email (email_id $idfield, email_subject VARCHAR(255) NULL, email_body TEXT NULL, email_from VARCHAR(50) NULL, email_reply VARCHAR(50) NULL, email_to VARCHAR(50) NULL, PRIMARY KEY (email_id));\n";
	## End Email
	
	## Favorites
	$query['inl_fav'] = "CREATE TABLE inl_fav (user_id INT DEFAULT '0' NOT NULL, link_id INT DEFAULT '0' NOT NULL);\n";
	
  	$query['inl_fav'].= "CREATE INDEX user_id ON inl_fav (user_id);\n";
  	$query['inl_fav'].= "CREATE INDEX fav_link_id ON inl_fav (link_id);\n";
	## End Favorites	
  
	## Link->Category RelationShips
	$query['inl_lc'] = "CREATE TABLE inl_lc (link_id INT DEFAULT '0' NOT NULL, cat_id INT DEFAULT '0' NOT NULL, link_pend INT DEFAULT '0' NOT NULL);\n";

  	$query['inl_lc'].= "CREATE INDEX link_id ON inl_lc (link_id);\n";
  	$query['inl_lc'].= "CREATE INDEX cat_id ON inl_lc (cat_id);\n";
  	$query['inl_lc'].= "CREATE INDEX link_pend ON inl_lc (link_pend);\n";
	## End Link->Category RelationShips
	
	## Links
	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_links_link_id_seq\"'::text) NOT NULL";
	$query['inl_links'] = "CREATE TABLE inl_links (link_id $idfield, link_name VARCHAR(254) NOT NULL, link_desc TEXT NOT NULL, link_url VARCHAR(254) NOT NULL, link_date INT DEFAULT '0' NOT NULL, link_user INT DEFAULT '0' NOT NULL, link_hits INT DEFAULT '0' NOT NULL, link_votes INT DEFAULT '0' NOT NULL, link_rating DECIMAL(6,4) DEFAULT '0.0000' NOT NULL, link_pick SMALLINT DEFAULT '0' NOT NULL, link_vis SMALLINT DEFAULT '0' NOT NULL, link_image VARCHAR(254) NULL, link_cust INT DEFAULT '0' NOT NULL, link_numrevs INT DEFAULT '0' NOT NULL, link_modified INT DEFAULT '0' NOT NULL, link_expires INT DEFAULT '0' NOT NULL, PRIMARY KEY (link_id));\n";
	
	$query['inl_links'].= "CREATE INDEX link_name ON inl_links (link_name);\n";
	$query['inl_links'].= "CREATE INDEX link_url ON inl_links (link_url);\n";
	$query['inl_links'].= "CREATE INDEX link_date ON inl_links (link_date);\n";
	$query['inl_links'].= "CREATE INDEX link_user ON inl_links (link_user);\n";
	$query['inl_links'].= "CREATE INDEX link_hits ON inl_links (link_hits);\n";
	$query['inl_links'].= "CREATE INDEX link_rating ON inl_links (link_rating);\n";
	$query['inl_links'].= "CREATE INDEX link_pick ON inl_links (link_pick);\n";
	$query['inl_links'].= "CREATE INDEX link_vis ON inl_links (link_vis);\n";
	$query['inl_links'].= "CREATE INDEX link_cust ON inl_links (link_cust);\n";
	$query['inl_links'].= "CREATE INDEX link_expires ON inl_links (link_expires);\n";	
	## End Links
	
	## Related Categories
	$query['inl_rel_cats'] = "CREATE TABLE inl_rel_cats (cat_id INT DEFAULT '0' NOT NULL, rel_id INT DEFAULT '0' NOT NULL);\n"; 
	
  	$query['inl_rel_cats'].= "CREATE INDEX rel_cat_id ON inl_rel_cats (cat_id);\n"; 
  	$query['inl_rel_cats'].= "CREATE INDEX rel_id ON inl_rel_cats (rel_id);\n"; 	## End Related Categories
	
	## Reviews
	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_reviews_rev_id_seq\"'::text) NOT NULL";
	$query['inl_reviews'] = "CREATE TABLE inl_reviews (rev_id $idfield, rev_link INT DEFAULT '0' NOT NULL, rev_user INT DEFAULT '0' NOT NULL, rev_text TEXT NULL, rev_date INT DEFAULT '0' NOT NULL, rev_pend INT DEFAULT '0' NOT NULL, PRIMARY KEY (rev_id));\n";
		
  	$query['inl_reviews'].= "CREATE INDEX rev_link ON inl_reviews (rev_link);\n";
	## End Reviews
	
	## Search Log
	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_search_log_log_id_seq\"'::text) NOT NULL";
	$query['inl_search_log'] = "CREATE TABLE inl_search_log (log_id $idfield, log_type SMALLINT DEFAULT '0' NOT NULL, log_date INT DEFAULT '0' NOT NULL, log_search SMALLINT DEFAULT '0' NOT NULL, log_keyword VARCHAR(255) DEFAULT '' NOT NULL, search_action INT DEFAULT '0' NOT NULL, search_cat INT DEFAULT '0' NOT NULL, PRIMARY KEY (log_id)) ;\n";
	## Search Log
	
   	## Sessions
	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_sessions_ses_id_seq\"'::text) NOT NULL";
  	$query['inl_sessions'] = "CREATE TABLE inl_sessions (ses_id  $idfield, ses_time INT DEFAULT '0' NOT NULL, user_id INT DEFAULT '0' NOT NULL, user_perm INT DEFAULT '0' NOT NULL, num_res VARCHAR(25) NULL, link_order VARCHAR(25) NULL, link_sort VARCHAR(25) NULL, cat_order VARCHAR(25) NULL, cat_sort VARCHAR(25) NULL, lang VARCHAR(25) NULL, theme VARCHAR(25) NULL, destin VARCHAR(250) NULL, PRIMARY KEY (ses_id));\n";
  
  	$query['inl_sessions'].= "CREATE INDEX ses_id ON inl_sessions (ses_id);\n";  	## End Sessions
	
	## Users
	if ($dbtype == "mysql")
		$inl_users_u = ", UNIQUE user_name (user_name)";
	elseif ($dbtype == "postgres7")
		$inl_users_u = ", UNIQUE (user_name)";
	elseif ($dbtype == "")
		$inl_users_u = "";

	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_users_user_id_seq\"'::text) NOT NULL";
	$query['inl_users'] = "CREATE TABLE inl_users (user_id $idfield, user_name VARCHAR(20) NOT NULL, user_pass VARCHAR(50) NOT NULL, first VARCHAR(50) NOT NULL, last VARCHAR(50) NOT NULL, email VARCHAR(255) NULL, user_perm INT DEFAULT '0' NOT NULL, user_date INT DEFAULT '0' NOT NULL, user_cust INT DEFAULT '0' NOT NULL, user_status SMALLINT DEFAULT '0' NOT NULL, user_pend INT DEFAULT '0' NOT NULL, last_ip VARCHAR(15) DEFAULT '' NOT NULL, PRIMARY KEY (user_id)  $inl_users_u);\n";
	## End Users
	
	## Votes
	$query['inl_votes'] = "CREATE TABLE inl_votes (stamp INT DEFAULT '0' NOT NULL, vote_ip VARCHAR(16) NOT NULL, vote_link INT DEFAULT '0' NOT NULL, rev INT DEFAULT '0' NOT NULL);\n";

   	$query['inl_votes'].= "CREATE INDEX stamp ON inl_votes (stamp);\n";
   	$query['inl_votes'].= "CREATE INDEX vote_ip ON inl_votes (vote_ip);\n";
   	$query['inl_votes'].= "CREATE INDEX vote_link ON inl_votes (vote_link);\n";
	## End Votes
	
	## Bans
   	if ($dbtype == "postgres7") $idfield = "int4 DEFAULT nextval('\"inl_sessions_ses_id_seq\"'::text) NOT NULL";
   	$query['inl_ban_list'] = "CREATE TABLE inl_ban_list (ban_id $idfield, ban_date INT DEFAULT '0' NOT NULL, ban_value VARCHAR(255) DEFAULT '' NOT NULL, ban_type INT DEFAULT '0' NOT NULL, ban_exclusion TEXT NOT NULL, PRIMARY KEY (ban_id));\n";
	## End Bans
	
	return $query;
}

function create_seq()
{
	global $conn;
	$query = "SELECT relname FROM pg_class WHERE NOT relname ~ 'pg_.*' AND relkind ='S' ORDER BY relname";
	$rs = $conn->Execute($query);
	if ( $rs AND !$rs->EOF )
	{
		//echo "<pre>";
		for ( $i = 1 ; $i <= $rs -> RecordCount() ; $i ++ )
		{
			
			$sequence = $rs -> fields["relname"];	
			$query_seq = "SELECT * FROM $sequence";
			$rs1 = $conn->Execute($query_seq);
			
			if ( $rs1 AND !$rs1->EOF )
			{			
				//print_r($rs1);
				$last_value = $rs1 -> fields["last_value"];	
				$increment_by = $rs1 -> fields["increment_by"];				
				$max_value = $rs1 -> fields["max_value"];	
				$min_value = $rs1 -> fields["min_value"];	
				$cache_value = $rs1 -> fields["cache_value"];	
				$ret.="CREATE SEQUENCE $sequence start $last_value increment $increment_by maxvalue $max_value minvalue $min_value cache $cache_value;\n";				
				if ( $last_value > 1 ) $ret.="SELECT NEXTVAL('$sequence'); \n";			
			}
			$rs -> MoveNext();
		}
	}
	return $ret;
}


?>

