<?php
/*	In-link Functions Library Version 2.1.4
	Miscellaneous Functions
	Included in config.php, required for all scripts

	Last updated 10/03/03
*/

function inl_escape($in)
{
	global $html_enable;

	$out = stripslashes($in);

	if($html_enable=="yes")
		{;}
	else
	{
		$out=ereg_replace("<","&lt;",$out);
		$out=ereg_replace(">","&gt;",$out);
		$out=ereg_replace("\"","&quot;",$out);
	}
	
	$out=addslashes($out);
	
	return $out;
}

function form_escape($in)
{	
	global $html_enable;
	$out=stripslashes($in);
	if($html_enable=="yes"){;}
	else
	{
		$out=ereg_replace("<","&lt;",$out);
		$out=ereg_replace(">","&gt;",$out);
		$out=ereg_replace("\"","&quot;",$out);
	}
	return $out;
}

function search_escape($in)
{
	$out = ereg_replace("_", "\_", $in);
	$out = ereg_replace("%", "\%", $out);
	$out = ereg_replace("<", "&lt;", $out);
    $out = ereg_replace(">", "&gt;", $out);
    $out = ereg_replace("&quot;", "\"", $out);
    
	return $out;
}

function error($str, $type)
{	switch($type)
	{	case 0:
			echo "	<p align=\"center\">&nbsp;</p>
					<p align=\"center\">&nbsp;</p>
					<p align=\"center\">&nbsp;</p>
					<p align=\"center\">&nbsp;</p><p align=\"center\"><b><font face=\"Arial, Verdana, Helvetica\" color=\"#FF0000\">IN-LINK FATAL ERROR:</font></b></p><br>\n<p align=\"center\"><font size=\"2\" face=\"Arial, Verdana, Helvetica\"><b>$str</b></font></font></p>";
			break;
		default:
			echo "	<p align=\"center\">&nbsp;</p>
					<p align=\"center\">&nbsp;</p>
					<p align=\"center\">&nbsp;</p>
					<p align=\"center\">&nbsp;</p><p align=\"center\"><b><font face=\"Arial, Verdana, Helvetica\" color=\"#FF0000\">IN-LINK ERROR:</font></b></p><br>\n<p align=\"center\"><font size=\"2\" face=\"Arial, Verdana, Helvetica\"><b>$str</b></font></font></p>";
	}
}

function inl_header($destin)
{	global $sid, $session_get, $HTTP_SERVER_VARS, $_local_login;
	
	if($sid && $session_get)
	{	if(substr($destin,-1)=="?" || substr($destin,-1)=="&") //only ? or &
			$addon="sid=$sid";
		elseif(strpos($destin,"?"))
			$addon="&sid=$sid";
		else
			$addon="?sid=$sid";

	}
	
	//$destin="http://".$HTTP_SERVER_VARS['HTTP_HOST']."/".dirname($HTTP_SERVER_VARS['PHP_SELF'])."/".$destin;

	if (isset($_local_login))
		header("Refresh: 0; URL=$destin$addon"); 
	else
		header("Location: $destin$addon");
	die();
}

/*	Login function
	Takes user name and password (plain text)
	returns		1  if success
				-1 if short user name
				-2 if session error
				-3 if database error
				-4 if wrong login (user w/ such name/pwd not found)
*/
function login($username, $password)
{	
	global $ses, $conn, $sid, $SERVER_NAME, $keya, $keyb, $REMOTE_ADDR, $_local_login;

	
	$res=check_key();

	if(strlen($username)<3 || strlen($password)<3)
		return -1;
	$username=inl_escape($username);
	$password=md5($password);

	$query="SELECT * FROM inl_users WHERE user_name='$username' and user_pass='$password' and user_pend!=1 and user_status!=0";
	$rs = &$conn->Execute($query);
	if(!$rs)
		return -3;

	$_local_login = true;		
		
	if (!$rs->EOF) 
	{			
		$sid = init_session();				
		if ($sid)
		{	
			$ses["user_id"] = $rs->fields["user_id"];
			$ses["user_perm"] = $rs->fields["user_perm"];			
			
			if(!save_session($sid))
				return -3;
		}
		else
			return -2; 						
	}
	else
		return -4;

	// UPDATE USER LAST IP ADDRESS, AFTER SUCCESSFULL LOGIN
	$sql = "UPDATE inl_users SET last_ip='$REMOTE_ADDR' WHERE user_id='".$ses["user_id"]."'";
	$rs = &$conn->Execute($sql);
	
	return 1;
}

function logout()
{	global $sid, $ses;

	if($sid)
	{	$ses["user_id"]=0;
		$ses["user_perm"]=0;
		save_session($sid);
	}
	//else - error: if user is logged in, there should be a session
}

function get_keyb($keya)
{	global $SERVER_NAME;

	if(strlen($SERVER_NAME)<1)
		return -1;
	if(strlen($keya)!=32)
		return -2;

	$nh=0;
	settype($nh,"integer");
	for($i=0;$i<strlen($SERVER_NAME);$i++)
		$nh+=ord($SERVER_NAME[$i]);
	$key=md5($SERVER_NAME.$iph.$keya);

	if(strlen($key)!=32)
		return -3;

	$key1=substr($key,0,8);
	$key2=substr($key,8,8);
	$key3=substr($key,16,8);
	$key4=substr($key,24,8);
	
	return $key3.$key2.$key4.$key1;
}

function check_perm($cat_perm=-1,$resource) //returns 0 if no, 1 if pend or 2 if direct
{	
	global $ses, $root_link_perm, $suggest_cat_perm, $review_perm, $rate_perm, $user_perm;
	
	switch($resource)
	{	
		case "link":
			if($cat_perm==-1) //root, or no info avail
				$cat_perm=$root_link_perm;
			break;
		case "cat":
			$cat_perm=$suggest_cat_perm;
			break;
		case "review":
			$cat_perm=$review_perm;
			break;
		case "rate": //special case for ratings - no pending choice
			if(($ses["user_id"] && $rate_perm<2) || (!$ses["user_id"] && $rate_perm%2==0))
				return 0;
			else
				return 2;
			break;
		case "user":
			return $user_perm;
	}
	if(($ses["user_id"]>0 && $cat_perm<3) || (!$ses["user_id"] && $cat_perm%3==0))
		return 0;
	if(($ses["user_id"]>0 && $cat_perm<6 && $cat_perm>2) || (!$ses["user_id"] && $cat_perm%3==1))
		return 1;
	if(($ses["user_id"]>0 && $cat_perm>5) || (!$ses["user_id"] && $cat_perm%3==2))
		return 2;
}

/*	Wrapper for DB insertion, when AutoIncrement ID needs to be overridden
*/
function insert_with_id($query,$table)
{	global $conn, $sql_type;
	
	if($sql_type=="mssql")
		$rs=&$conn->Execute("SET identity_insert $table ON");	

	$rs=&$conn->Execute($query);	
	return $rs;
}

## Modified in In-link 2.3.3
function do_ban($value, $type, $action, $exclusion="", $id="")
{ 
	global $conn, $sql_type;

	$exclusion	= trim($exclusion);
	$value		= trim($value);

	if ($action == 1)
	{
		if (strlen($exclusion) && ($exclusion[strlen($exclusion)-1] != ","))
			$exclusion.= ",";
	
		$sql = "UPDATE inl_ban_list SET ban_value='".$value."', ban_exclusion='".$exclusion."' WHERE ban_id='".$id."'";	
	}
	elseif ($action == 2)
	{
		$sql = "DELETE FROM inl_ban_list WHERE ban_id='".$id."'";
	}

	elseif (($action == 4) || ($action == 5))
	{
		# ADD TO EXCLUSIONs
		if ($action == 4)					
		{
			if (($sql_type != "mysql") && ($sql_type != "mssql"))
				$sql = "UPDATE inl_ban_list SET ban_exclusion = overlay(ban_exclusion,'".$value.",') WHERE ban_type = '3' AND ((STRPOS(ban_exclusion, '".$data.",') < 1) AND (STRPOS('".$data."', ban_value) > 0))";	
			elseif ($sql_type == "mysql")
				$sql = "UPDATE inl_ban_list SET ban_exclusion = CONCAT(ban_exclusion, '".$value.",') WHERE ban_type = '3' AND ((INSTR(ban_exclusion, '".$value.",') < 1) AND (INSTR('".$value."', ban_value) > 0))";
			elseif ($sql_type == "mssql")
				$sql = "UPDATE inl_ban_list SET ban_exclusion = ban_exclusion + '".$value.",' WHERE ban_type = '3' AND ((CHARINDEX('".$value.",', ban_exclusion) < 1) AND (CHARINDEX(ban_value, '".$value."') > 0))";
		}
		else # COMPLETELY UNBAN (remove record)
		{
			if (($sql_type != "mysql") && ($sql_type != "mssql"))
				$sql = "DELETE FROM inl_ban_list WHERE ban_type = '3' AND ((STRPOS('".$data.",', ban_exclusion) < 1) AND (STRPOS(ban_value, '".$data."') > 0))";
			elseif ($sql_type == "mysql")
				$sql = "DELETE FROM inl_ban_list WHERE ban_type = '3' AND ((INSTR(ban_exclusion, '".$value.",') < 1) AND (INSTR('".$value."', ban_value) > 0))";
			elseif ($sql_type == "mssql")
			{
				$sql = "DELETE FROM inl_ban_list WHERE ban_type = '3' AND ((CHARINDEX('".$value.",', ban_exclusion) < 1) AND (CHARINDEX(ban_value, '".$value."') > 0))";
			}	
		}
	
	}
	else
	{
		if ($type == 3)
		{
			if (($sql_type != "mysql") && ($sql_type != "mssql"))
				$sql = "UPDATE inl_ban_list SET ban_exclusion = replace(ban_exclusion, '".$value.",', '') WHERE ban_type = '3' AND ((STRPOS('".$data.",', ban_exclusion) < 1) AND (STRPOS(ban_value, '".$data."') > 0))";
			elseif ($sql_type == "mysql")
			{
				$sql = "UPDATE inl_ban_list SET ban_exclusion = REPLACE(ban_exclusion, '".$value.",', '') WHERE ban_type = '3' AND (INSTR(ban_exclusion, '".$value.",')>0)";
			}
			elseif ($sql_type == "mssql")
			{
				$sql = "UPDATE inl_ban_list SET ban_exclusion = REPLACE(ban_exclusion, '".$value.",', '') WHERE ban_type = '3' AND (CHARINDEX('".$value.",', ban_exclusion)>0)";	
			}
		
			$rs = &$conn->Execute($sql);
			
			$ExclusionRemoved = 0;
			if($rs && ($conn->Affected_Rows()>0))
				$ExclusionRemoved = 1;
		
		}
		
		// echo $sql."<BR>"; 
		

		if (!$ExclusionRemoved)
		{
			$value = RemoveFromStart($value);
			
			$sql = "SELECT * FROM inl_ban_list WHERE ban_type='".$type."' AND ban_value='".$value."'";
			$rs = &$conn->Execute($sql);
			if ($rs && $rs->EOF)
			{	
				$sql = "INSERT INTO inl_ban_list (ban_date, ban_value, ban_type) VALUES ('".time()."', '".$value."', '".$type."')";
			}
			else
				$sql = "";
		}
	}
	
	// echo $sql."<BR>"; 
	
	if (strlen($sql))
		$rs = &$conn->Execute($sql);
		
}

function ban_check($value, $type)
{ global $conn;

	$sql = "SELECT * FROM inl_ban_list WHERE ban_type='".$type."' ORDER BY ban_date ASC";
	$rs = &$conn->Execute($sql);
	
	$ret = 1;

	while ($rs && !$rs->EOF)
	{
		
		if (eregi($rs->fields['ban_value'], $value))
		{
			$ret = 0;
			$_list = $rs->fields['ban_exclusion'];

	
			if ($_list && $_list != NULL && (strlen($_list)>0))
			{
				$_list_array = explode(",", $_list);
				foreach ($_list_array as $cur => $val)
				{
					if ($val == $value)
					{
						$_super_ret = 1;
						return $_super_ret;
					}
				}
			}
		}
		
		$rs->MoveNext();
	}	

	return $ret;
}

function _GetBannedLinks($data)
{ 
	global $conn, $sql_type;

	if (($sql_type != "mysql") && ($sql_type != "mssql"))
		$sql = "SELECT * FROM inl_ban_list WHERE ban_type = '3' AND ((STRPOS(ban_exclusion, '".$data.",') < 1) AND (STRPOS('".$data."', ban_value) > 0))";
	elseif ($sql_type == "mysql")
		$sql = "SELECT * FROM inl_ban_list WHERE ban_type = '3' AND ((INSTR(ban_exclusion, '".$data.",') < 1) AND (INSTR('".$data."', ban_value) > 0))";
	elseif ($sql_type == "mssql")
		$sql = "SELECT * FROM inl_ban_list WHERE ban_type = '3' AND ((CHARINDEX('".$data.",', ban_exclusion) < 1) AND (CHARINDEX(ban_value, '".$data."') > 0))";
	
	$rs = &$conn->Execute($sql);
	$ret = ($rs && $rs->RecordCount())? 1 : 0;		

	return $ret;
}

## Modified in In-link 2.3.3
function CheckEditorPerm($value, $user_id, $type = "", $add = "")
{ 
	global $conn, $res, $link_data, $ses;

	$ret = 0;
	$counter = 0;

	if ($type == "AddLinkToCat")
	{
		$catb = $value;
		$prevCatUser = -1;
				
		if ($value > 0) 
		{	
			## Root OR Admin
			if (($ses["user_perm"] > 0) && ($ses["user_perm"] < 3))
				$ret = 1;
			else
			{
				do
				{
					$sql = "SELECT cat_name, cat_sub, cat_id, cat_user FROM inl_cats WHERE cat_id='$catb'";				
					$rs = &$conn->Execute($sql);
					if (!$rs->EOF && $rs) 
					{
						
					    if (($prevCatUser != -1) && (($rs->fields[3] == 0) || ($rs->fields[3] == $user_id)))
						{				
							$ret = 1;	
						}
						elseif (($prevCatUser == -1) && ($rs->fields[3] == $user_id))
						{
				
							$ret = 1;
							break;
						}
						elseif (($prevCatUser == -1) && ($rs->fields[3] != $user_id))
						{
							$ret = 0;
						}
						else
						{
				     		$ret = 0;
							break;
						}
						$prevCatUser = $rs->fields[3];			
						$catb = $rs->fields[1];
						$counter++;
					}
				} 
				while ($catb != "0" && (!$rs->EOF && $rs));	
			}		
		}		
		elseif ($value == 0)
		{
			$ret = (($ses["user_perm"] > 0) && ($ses["user_perm"] < 3))? 1 : 0;			
		}
		else
			$ret = 0;		 
	}
	elseif ($type == "EditLinkToCat")
	{
		$sql = "SELECT cat_id, link_pend FROM inl_lc WHERE link_id='$value' AND link_pend>='0'";
		$rs = &$conn->Execute($sql);
		
		// ONLY ONE LINK COPY OWNER
		if (($rs->RecordCount()<2) && (CheckEditorPerm($rs->fields[0], $user_id, "AddLinkToCat")))
		{
	
			if ($rs->fields[0] != 0)
				$ret = 1;
			else
				$ret = 0;
		}
		elseif ($rs && !$rs->EOF)
		{
	
			while ($rs && !$rs->EOF) 
			{
				$currCat = $rs->fields[0];
	           
				if (!CheckEditorPerm($currCat, $user_id, "AddLinkToCat") || ($currCat == 0) || ($rs->fields[1]<0))
				{
				    $ret = 0;
					break;
				}
				else
					$ret = 1;
					
				$rs->MoveNext();
			}
		
		}
		else
		  $ret = 0;
	}
	elseif ($type == "DeleteALLCopiesOfUserLink")
	{

		$sql = "SELECT cat_id, cat_user FROM inl_lc LEFT JOIN inl_cats ON inl_lc.cat_id=inl_cats.cat_id";
		$rs = &$conn->Execute($sql);

		while ($rs && !$rs->EOF) 
		{
			if ($rs->fields[1] == $user_id)
				$in.= $rs->fields[0].", ";
			else
				$notCompleteDelete = 1;

			$rs->MoveNext();
		}

		$in = eregi_replace(", $", "", $in);
		$sql = "DELETE FROM inl_lc WHERE cat_id IN ($in) AND link_id='$value'";
		$rs = &$conn->Execute($sql);

		if ($notCompleteDelete == 1)
		{
			$rs = &$conn->Execute("select link_cust from inl_links where link_id='$value'");
			if ($rs && !$rs->EOF)
				if ($rs->fields[0])
					$conn->Execute("delete from inl_custom where cust_id='".$rs->fields[0]."'");

			//delete link itself
			$conn->Execute("delete from inl_links where link_id='$value'");

			//clean up references (should already be Ok);
			$conn->Execute("delete from inl_lc where link_id='$value'");

			$conn->Execute("delete from inl_reviews where rev_link='$value'");
		}	

		update_all_link_count();	
		
	}

	return $ret;
}
## End Modified


function get_cat_id_for_link($link_id)
{ global $conn, $ses;
	
	$res = &$conn->Execute("SELECT cat_id FROM inl_lc WHERE link_id=$link_id");
	if ($res)
	{
		$current_cat_id = $res->fields[0];
		
		$res = &$conn->Execute("SELECT cat_user FROM inl_cats WHERE cat_id=$current_cat_id");
		if ($res)
			$current_cat_user = $res->fields[0];
	}
		
	if ($ses["user_id"] == $current_cat_user)
		return true;
	else 
		return false;
}

function RemoveFromStart($value)
{	
	$SetToRemove = array('http://', 'ftp://', 'www.');
	
	$value = trim($value, " \t./");
	foreach ($SetToRemove as $val)
		$value = eregi_replace("^".$val, "", $value);

	$ret = $value;

	return $ret;
}

function GetLinksResultsOffSet($_local_sql, $start, $lim)
{
	global $conn;
        
	if ($start != 0)
	{
		$rs = &$conn->SelectLimit($_local_sql, $start, 0);
		while ($rs && !$rs->EOF) 
		{
			$recordStartSUM = $recordStartSUM + $rs->fields[0];
			$rs->MoveNext();
		}			
		$_local_start = $recordStartSUM;
		
	}
	else
		$_local_start = $start;
    
	$rs = &$conn->SelectLimit($_local_sql, $lim, $start);
	while ($rs && !$rs->EOF) 
	{
		$recordCountSUM = $recordCountSUM + $rs->fields[0];
		$rs->MoveNext();
	}
	if ($recordCountSUM > $lim)
		$_local_lim = $recordCountSUM;
	else
		$_local_lim	= $lim;

	$ret['lim'] = $_local_lim;
	$ret['start'] = $_local_start;
	
	return $ret;
}

## Modified in In-link 2.3.3
function dropTable($tableName)
{
    global $conn, $sql_type;
    
    $add_sql = ($sql_type == "mysql")? "IF EXISTS " : "";
    $sql = "DROP TABLE ".$add_sql.$tableName;  
    $rs = &$conn->Execute($sql);
   	
    return $ret;       
}


function dropNonExcistingSessionsTables($name, $type)
{
    global $conn, $systemTables, $validate_table_name, $static_validate_table;
    
    $toDrop = "";
    
    ## Get all currently exsisting sessions
    if ($type == "validation")
    {
    	$add_sql = $static_validate_table? " OR user_perm='1' OR user_perm='2' OR user_perm='5')" : ")";
    	$sql = "SELECT user_id FROM inl_users WHERE (user_name='root'$add_sql AND user_status='1' AND user_pend='0'";    		
    }
    else 
    {
    	$sql = "SELECT ses_id FROM inl_sessions ".$type;
    	$pattern = "nl_validate_";
    } 
    
    if (strlen($sql) && $rs = &$conn->Execute($sql))
    {
	    while ($rs && !$rs->EOF)
	    {
	        $donotDROP[] = $name.$rs->fields[0];        
	        $rs->MoveNext();    
	    }
    }
    elseif ($type == "validation")
    	$donotDROP[] = $validate_table_name;
    	
    if(!is_array($donotDROP))
    	$donotDROP = (array)$donotDROP;
    	
   	## Get list of all tables
    $sql = "SHOW TABLES";
    if ($rs = &$conn->Execute($sql))
    {
	    while ($rs && !$rs->EOF)
	    {
			if (eregi("^inl_", $rs->fields[0]))
			{
	    		if (!in_array($rs->fields[0], $systemTables) && !in_array($rs->fields[0], $donotDROP))
		        {
		            if (!strlen($pattern) || (strlen($pattern) && !eregi($pattern, $rs->fields[0]))) 	        			        	$listToDrop.= $rs->fields[0].", ";
		        }
			}
			
	        $rs->MoveNext();    
	    }
    }
    
    ## Check and drop all old tables   
    if (strlen($listToDrop)>3)
    {
        $listToDrop = eregi_replace(", $", "", $listToDrop);
        dropTable($listToDrop); 
    }
      
    return $ret;   
}
## End modified

function getSearchVars($having)
{
	global $conn, $SearchLogData;
    
	$SearchLogData = array();
	
	$que = "SELECT log_keyword, log_search, search_action, search_cat, log_type FROM inl_search_log where log_id='$having'";
	$rs = &$conn->Execute($que);

	if ($rs && !$rs->EOF) 
	{
		// STORE
		$SearchLogData['search_word']		 = stripslashes($rs->fields[0]);
		$SearchLogData['search_type']	  	 = $rs->fields[1];
		$SearchLogData['act']				 = $rs->fields[2];
		$SearchLogData['cat']				 = $rs->fields[3];
		$SearchLogData['search_cat_or_link'] = $rs->fields[4];
	}
}

function AddGetExpirationToQuery($time, $type = null)
{
	$ret = ($type == null)? " ((link_expires = '0') OR (link_expires > '".$time."')) " : " ((link_expires != '0') AND (link_expires < '".$time."'))  ";
        
	return $ret;
}


##### All functions below added in 2.3.3 ########

/**
 * @return void
 * @param string $type, string $sign
 * @desc updateTotalCounters - gets and updates links or categories counter depending passed parameter
*/
function updateTotalCounters($type, $sign = "recount")
{
	global $conn, $sql_type, $total_link_counter, $total_cat_counter;
		
	if (($type == "links") || ($type == "links_cats"))
	{
		if ($sign == "recount")
		{
			$sql = ($sql_type != "postgres7")? "SELECT COUNT(link_id) FROM inl_lc WHERE link_pend=0" : "SELECT DISTINCT ON (link_id) COUNT(link_id) FROM inl_lc WHERE link_pend=0";	
			
			// echo "COUNTING LINKS: $sql<BR>";
			
			if ($rs = &$conn->Execute($sql))
				$total_link_counter = ($rs && !$rs->EOF)? $rs->fields[0] : 0;
			else
				$total_link_counter = 0;
						
			$sql = "UPDATE inl_config SET value='$total_link_counter' WHERE name='total_link_counter'";		
		}
		else
		{
			$total_link_counter	+= (int)$sign;						
			$sql = "UPDATE inl_config SET value='$total_link_counter' WHERE name='total_link_counter'";		
		}			
		$rs = &$conn->Execute($sql);
		
	}
	
	if (($type == "cats") || ($type == "links_cats"))
	{
		if ($sign == "recount")
		{
			$sql = ($sql_type != "postgres7")? "SELECT COUNT(cat_id) FROM inl_cats WHERE cat_pend=0" : "SELECT DISTINCT ON (cat_id) COUNT(cat_id) FROM inl_cats WHERE cat_pend=0";	
			if ($rs = &$conn->Execute($sql))
				$total_cat_counter = ($rs && !$rs->EOF)? $rs->fields[0] : 0;
			else
				$total_cat_counter = 0;						
			
			// echo "COUNTING CATS: $sql<BR>";	
				
			$sql = "UPDATE inl_config SET value='$total_cat_counter' WHERE name='total_cat_counter'";
		}
		else
		{
			$total_cat_counter += (int)$sign;						
			$sql = "UPDATE inl_config SET value='$total_cat_counter' WHERE name='total_cat_counter'";		
		}				
		$rs = &$conn->Execute($sql);		
	}	
	
	return void;
}

/**
 * @return void 
 * @desc updateTopLinkValues - gets and updates top values for link rating or hits
*/
function updateTopLinkValues()
{
	global $conn;
			
	$sql = "SELECT MAX(link_hits), MAX(link_rating) FROM inl_links";
	
	if ($rs = &$conn->Execute($sql))
	{
		if ($rs && !$rs->EOF)
		{
			$top_link_hits =  $rs->fields[0]? $rs->fields[0] : 1;
			$top_link_rating = $rs->fields[1]? $rs->fields[1] : 1;	
		}
		else
		{
			$top_link_hits = 1;
			$top_link_rating = 1;
		}
		$sql = "UPDATE inl_config SET value='$top_link_hits' WHERE name='top_link_hits'";	
		$rs = &$conn->Execute($sql);	
		
		$sql = "UPDATE inl_config SET value='$top_link_rating' WHERE name='top_link_rating'";	
		$rs = &$conn->Execute($sql);	
	}	
	
	return void;
}

/**
 * @return void
 * @param string $type
 * @desc updateMinMaxValues - gets and updates links or categories counter depending passed parameter
*/
function updateMinMaxValues($type = "hits_rating")
{
	global $conn, $link_top, $link_pop;
	
	if (!$link_top)
		$link_top = 5;
		
	if (!$link_pop)
		$link_pop = 5;
	
	if (($type == "hits") || ($type == "hits_rating"))
	{
		$sql = "SELECT link_hits FROM inl_links ORDER BY link_hits DESC";			
		if ($rs = &$conn->SelectLimit($sql, $link_pop, 0))
			$min_top_link_hits = ($rs && !$rs->EOF)? $rs->fields[0] : 0;
		else
			$min_top_link_hits = 0;
			
		$sql = "UPDATE inl_config SET value='$min_top_link_hits' WHERE name='min_top_link_hits'";		
		$rs = &$conn->Execute($sql);
	}
	
	if (($type == "rating") || ($type == "hits_rating"))
	{
		$sql = "SELECT link_rating FROM inl_links ORDER BY link_rating DESC";	
		if ($rs = &$conn->SelectLimit($sql, $link_top, 0))
			$min_top_link_rating = ($rs && !$rs->EOF)? $rs->fields[0] : 0;
		else
			$min_top_link_rating = 0;						
			
		$sql = "UPDATE inl_config SET value='$min_top_link_rating' WHERE name='min_top_link_rating'";
		$rs = &$conn->Execute($sql);		
	}	
	
	return void;
}

function updateTotalLinkHitsSum($sign = "recount")
{
	global $conn, $total_link_hits_sum;
	
	if ($sign == "recount")
	{
		$sql = "SELECT SUM(link_hits) FROM inl_links";	
		if ($rs = &$conn->Execute($sql))
			$total_link_hits_sum_new = ($rs && !$rs->EOF)? $rs->fields[0] : 0;			
		else
			$total_link_hits_sum_new = 0;						

		$total_link_hits_sum = ($total_link_hits_sum > $total_link_hits_sum_new)? $total_link_hits_sum : $total_link_hits_sum_new;	
				
		$sql = "UPDATE inl_config SET value='$total_link_hits_sum' WHERE name='total_link_hits_sum'";
	}
	else
	{
		
		$total_link_hits_sum += (int) $sign;
		$sql = "UPDATE inl_config SET value=value+1 WHERE name='total_link_hits_sum'";
	}
	$rs = &$conn->Execute($sql);	
	
	return void;
}   

function ValidationTable($action = null)
{
	global $conn, $ses, $validate_table_name, $sql_type;
	
	##  Drop existing user specific validation table!
	if (($action == "recreate") || ($action == "drop"))
	{
		dropTable($validate_table_name);		
	}
	
	## Check if validation table already exists
	if ($action == "reuse")
	{
		$sql = "SELECT link_id FROM ".$validate_table_name;
		$tableExists = ($rs = &$conn->Execute($sql))? 1 : 0;
	}
		
	## Create new user specific validation table!
	if (is_null($action) || ($action == "recreate") || (($action == "reuse") && !$tableExists))
	{		
		if ($sql_type == "mysql")
			$idfield = "INT NOT NULL auto_increment";
		elseif ($sql_type == "postgres7")
			$idfield = "serial";
		elseif ($sql_type == "mssql")
			$idfield = "INT IDENTITY (1, 1) NOT NULL ";
		
		$sql = "CREATE TABLE $validate_table_name (
	  	rec_id $idfield,
	  	link_id INT NOT NULL default '0',
	  	message VARCHAR(225) NOT NULL default '',
	  	code_id INT NOT NULL default '0',
	  	status INT NOT NULL default '0',
	 	valid_time INT NOT NULL default '0',
	 	selected INT NOT NULL default '0',
	    PRIMARY KEY (rec_id))";
		$rs = &$conn->Execute($sql);
		
		if ($sql_type == "mysql")
			$sql = "ALTER TABLE $validate_table_name ADD UNIQUE link_id (link_id), ADD INDEX status (status)";				elseif ($sql_type == "mssql")
			
			
		$rs = &$conn->Execute($sql);
		
		## Insert first record as a system status
		$sql = "INSERT INTO $validate_table_name (link_id) VALUES ('0')";
		$rs = &$conn->Execute($sql);
	}
		
	return void;
}

function checkQuarantinStatus($linkID)
{
	global $conn, $ses, $validate_table_name;

	$sql = "SELECT link_id FROM $validate_table_name WHERE link_id='$linkID'";
	$rs = &$conn->Execute($sql);
	$ret = ($rs && !$rs->EOF && $rs->fields[0]>0)? 1 : 0;	
	
	return $ret;
}

function do_quarantine($linkID)
{
	global $conn, $ses, $la_not_validated_yet_mes, $validate_table_name;

	ValidationTable("reuse");
	
	$la_not_validated_yet_mes = inl_escape($la_not_validated_yet_mes);
		
	$sql = "INSERT INTO $validate_table_name (link_id, message, code_id, status, valid_time, selected) VALUES ('$linkID', '$la_not_validated_yet_mes', '', '2', '".time()."', '0')";
	$rs = &$conn->Execute($sql);

	return $ret;
}

function quarantine_functions($action, $linkID = null)
{
	global $conn, $validate_table_name;
	
	switch ($action)
	{
		case "cleanup":
			$sql = "DELETE FROM $validate_table_name WHERE link_id!='0'";
			break;
			
		case "unqaurantine":
			if ($linkID>0)
				$sql = "DELETE FROM $validate_table_name WHERE link_id='$linkID' AND link_id!='0'";
			break;
			
		case "remove_valid_links": 
			$sql = "DELETE FROM $validate_table_name WHERE status='1' AND link_id!='0'";
			break;
			
		case "get_dead_links":
			$sql = "SELECT link_id FROM $validate_table_name WHERE status='0' AND link_id!='0'";
			break;		
				
		case "select_all":
			$sql = "UPDATE $validate_table_name SET selected='1' WHERE link_id!='0'";
			break;
			
		case "select_all_dead":
			## Unselect All
			$sql = "UPDATE $validate_table_name SET selected='0' WHERE link_id!='0'";
			$rs = &$conn->Execute($sql);
			## Select All dead
			$sql = "UPDATE $validate_table_name SET selected='1' WHERE link_id!='0' AND status='0'";
			break;	
			
		case "select_all_suspects":		
			## Unselect All
			$sql = "UPDATE $validate_table_name SET selected='0' WHERE link_id!='0'";
			$rs = &$conn->Execute($sql);
			## Select All dead
			$sql = "UPDATE $validate_table_name SET selected='1' WHERE link_id!='0' AND status='2'";
			break;
				
		case "unselect_all":			
			## Unselect All
			$sql = "UPDATE $validate_table_name SET selected='0' WHERE link_id!='0'";			
			break;	
			
		case "delete_selected":
			$sql = "SELECT link_id FROM $validate_table_name WHERE selected='1' AND link_id!='0'";
			$rs = &$conn->Execute($sql);
			while ($rs && !$rs->EOF)
			{
				$ret[$rs->fields[0]] = "all";
				$rs->MoveNext();			
			}
			$sql = "";			
			break;	
			
		case "unmark_selected":			
			## unmark all selected
			$sql = "DELETE FROM $validate_table_name WHERE link_id!='0' AND selected='1'";			
			break;	
	}
		
	if (strlen($sql))
		$rs = &$conn->Execute($sql);
		
	if ($action == "get_dead_links")
	{
		while ($rs && !$rs->EOF)
		{
			$ret[$rs->fields[0]] = "all";
			$rs->MoveNext();	
		}	
	}	
	
	return $ret;
}

function save_curr_validation_screen($page_linkIDs, $selectedlinkIDs)
{
	global $conn, $validate_table_name;
	
	if (!is_array($selectedlinkIDs))
		$selectedlinkIDs = (array)$selectedlinkIDs;
	
	if (count($page_linkIDs))
	{
		foreach ($page_linkIDs as $linkID)		
		{
			if (array_key_exists($linkID, $selectedlinkIDs))
				$selectedIDs.= $linkID.", ";
			else
				$nonselectedIDs.= $linkID.", ";
		}
		
		$selectedIDs = ereg_replace(", $", "", $selectedIDs);
		$nonselectedIDs = ereg_replace(", $", "", $nonselectedIDs);
		
		if (strlen($selectedIDs))
		{
			$sql = "UPDATE $validate_table_name SET selected='1' WHERE link_id IN ($selectedIDs)";
			$rs = &$conn->Execute($sql);
		}
		
		if (strlen($nonselectedIDs))
		{
			$sql = "UPDATE $validate_table_name SET selected='0' WHERE link_id IN ($nonselectedIDs)";
			$rs = &$conn->Execute($sql);
		}			
	}	
}

function get_root_user()
{
	global $conn;
	
	$query="SELECT * FROM inl_users WHERE user_name='root'";
	$rs = &$conn->Execute($query);
	$ret = ($rs && !$rs->EOF && $rs->fields[0])? $rs->fields : 0;
	
	return $ret;
}
######### End added in 2.3.3 ##########

?>